
.386p

        NAME    A_LIN

        .model small, c

DGROUP  GROUP   _DATA


_DATA   SEGMENT DWORD PUBLIC USE32 'DATA'

EXTERN  _SVGA_virtualX : dword

_DATA   ENDS



_TEXT   SEGMENT BYTE PUBLIC USE32 'CODE'
                ASSUME  CS:_TEXT ,DS:DGROUP,SS:DGROUP

PUBLIC  _LIN_movSpr_
PUBLIC  _LIN_movWin_

PUBLIC  _L256_memset
PUBLIC  _L256_movSpr2_
PUBLIC  _L256_movWin2_

PUTSPR41        MACRO
LOCAL LPS_skip4, LPS_d1, LPS_d2, LPS_d3, LPS_d4
LOCAL LPS_n1, LPS_n2, LPS_n3, LPS_n4, LPS_next

        lodsd
        or      eax,eax
        je      LPS_skip4
        mov     edx,eax
        shr     edx,16
        or      al,al
        je      LPS_d1
        or      ah,ah
        je      LPS_d2
        or      dl,dl
        je      LPS_d3
        or      dh,dh
        je      LPS_d4
        mov     es:[edi],eax
LPS_skip4:
        add     edi,4
        jmp     LPS_next
LPS_d1:
        inc     edi
        jmp     LPS_n1
LPS_d2:
        stosb
        jmp     LPS_n2
LPS_d3:
        stosw
        jmp     LPS_n3
LPS_d4:
        stosw
        mov     es:[edi],dl
        inc     edi
        jmp     LPS_n4
LPS_n1:
        or      ah,ah
        je      LPS_n2
        mov     es:[edi],ah
LPS_n2:
        inc     edi
        or      dl,dl
        je      LPS_n3
        mov     es:[edi],dl
LPS_n3:
        inc     edi
        or      dh,dh
        je      LPS_n4
        mov     es:[edi],dh
LPS_n4:
        inc     edi
LPS_next:
        ENDM

PUTSPR4         MACRO
LOCAL LPS_skip4, LPS_d1, LPS_d2, LPS_d3, LPS_d4
LOCAL LPS_n1, LPS_n2, LPS_n3, LPS_n4, LPS_next
LOCAL   LPS_load

LPS_load:
        lodsd
        or      eax,eax
        je      LPS_skip4
        mov     edx,eax
        shr     edx,16
        or      al,al
        je      LPS_d1
        or      ah,ah
        je      LPS_d2
        or      dl,dl
        je      LPS_d3
        or      dh,dh
        je      LPS_d4
        mov     es:[edi],eax
LPS_skip4:
        add     edi,4
        jmp     LPS_next
LPS_d1:
        inc     edi
        jmp     LPS_n1
LPS_d2:
        stosb
        jmp     LPS_n2
LPS_d3:
        stosw
        jmp     LPS_n3
LPS_d4:
        stosw
        mov     es:[edi],dl
        inc     edi
        jmp     LPS_n4
LPS_n1:
        or      ah,ah
        je      LPS_n2
        mov     es:[edi],ah
LPS_n2:
        inc     edi
        or      dl,dl
        je      LPS_n3
        mov     es:[edi],dl
LPS_n3:
        inc     edi
        or      dh,dh
        je      LPS_n4
        mov     es:[edi],dh
LPS_n4:
        inc     edi
LPS_next:
        dec     ecx
        jne     LPS_load
        ENDM

PUTSPRR3         MACRO
LOCAL   LPS_rest1, LPS_rest2, LPS_rest3, LPS_rest4
        mov     eax,[esi]
LPS_rest1:
        or      al,al
        je      LPS_rest2
        mov     es:[edi],al
LPS_rest2:
        or      ah,ah
        je      LPS_rest3
        mov     es:[edi+1],ah
LPS_rest3:
        shr     eax,16
        je      LPS_rest4
        mov     es:[edi+2],al
LPS_rest4:
                ENDM

PUTSPRR2         MACRO
LOCAL   LPS_rest1, LPS_rest2, LPS_rest3
        mov     eax,[esi]
LPS_rest1:
        or      al,al
        je      LPS_rest2
        mov     es:[edi],al
LPS_rest2:
        or      ah,ah
        je      LPS_rest3
        mov     es:[edi+1],ah
LPS_rest3:
                ENDM

PUTSPRR1         MACRO
LOCAL   LPS_rest1, LPS_rest2
        mov     eax,[esi]
LPS_rest1:
        or      al,al
        je      LPS_rest2
        mov     es:[edi],al
LPS_rest2:
                ENDM


_LIN_movSpr_     PROC USES esi edi eax ebx ecx edx,
        dst        : dword, dstFormatX : dword,
        src        : dword, srcFormatX : dword,
        srcSizeX   : dword, srcSizeY   : dword

        mov     ebx,srcSizeY
        or      ebx,ebx
        je      LPS_end

        mov     eax,srcSizeX
        mov     ecx,eax
        and     eax,3

        mov     edx,srcFormatX
        sub     edx,ecx
        add     edx,eax
        mov     srcFormatX,edx
        mov     edx,dstFormatX
        sub     edx,ecx
        add     edx,eax
        mov     dstFormatX,edx

        shr     ecx,2
        mov     srcSizeX,ecx

        mov     esi,src
        mov     edi,dst

        je      LPS_rest

LPS_loopY:
        or      eax,eax
        je      LPS_put4x
        dec     eax
        je      LPS_put1
        dec     eax
        je      LPS_put2
        jmp     LPS_put3

LPS_put4x:
        cmp     ecx,1
        je      LPS_put41x
LPS_put4:
        PUTSPR4
        mov     ecx,srcSizeX
        add     edi,dstFormatX
        add     esi,srcFormatX
        dec     ebx
        jne     LPS_put4
        jmp     LPS_end

LPS_put41x:
        mov     ecx,dstFormatX
        push    ebp
        mov     ebp,srcFormatX
LPS_put41:
        PUTSPR41
        add     edi,ecx
        add     esi,ebp
        dec     ebx
        jne     LPS_put41
        jmp     LPS_ret

LPS_put3:
        PUTSPR4
        PUTSPRR3
        mov     ecx,srcSizeX
        add     edi,dstFormatX
        add     esi,srcFormatX
        dec     ebx
        jne     LPS_put3
        jmp     LPS_end

LPS_put2:
        PUTSPR4
        PUTSPRR2
        mov     ecx,srcSizeX
        add     edi,dstFormatX
        add     esi,srcFormatX
        dec     ebx
        jne     LPS_put2
        jmp     LPS_end

LPS_put1:
        PUTSPR4
        PUTSPRR1
        mov     ecx,srcSizeX
        add     edi,dstFormatX
        add     esi,srcFormatX
        dec     ebx
        jne     LPS_put1
        jmp     LPS_end

LPS_rest:
        or      eax,eax
        je      LPS_end

        mov     ecx,dstFormatX
        push    ebp
        mov     ebp,srcFormatX

        dec     eax
        je      LPS_rest1x
        dec     eax
        je      LPS_rest2x
        jmp     LPS_rest3x

LPS_rest3x:
        PUTSPRR3
        add     edi,ecx
        add     esi,ebp
        dec     ebx
        jne     LPS_rest3x
        jmp     LPS_ret
LPS_rest2x:
        PUTSPRR2
        add     edi,ecx
        add     esi,ebp
        dec     ebx
        jne     LPS_rest2x
        jmp     LPS_ret
LPS_rest1x:
        PUTSPRR1
        add     edi,ecx
        add     esi,ebp
        dec     ebx
        jne     LPS_rest1x
        jmp     LPS_ret
LPS_ret:
        pop     ebp
LPS_end:
        ret
_LIN_movSpr_    ENDP



_LIN_movWin_    PROC USES esi edi eax ebx ecx edx,
        dst        : dword, dstFormatX : dword,
        src        : dword, srcFormatX : dword,
        srcSizeX   : dword, srcSizeY   : dword

        mov     edi,dst
        mov     esi,src
        mov     ecx,srcSizeX
        mov     eax,ecx
        mov     edx,dstFormatX
        sub     edx,ecx
        mov     ebx,srcFormatX
        sub     ebx,ecx
        shr     ecx,2
        je      LPW_rest

LPW_move:
        and     eax,3
        je      LPW_move0
        dec     eax
        je      LPW_move1
        dec     eax
        je      LPW_move2
        dec     eax
        jmp     LPW_move3

LPW_move0:
        or      eax,srcSizeY
        je      LPW_ret
        cmp     ecx,1
        je      LPW_move4
        push    ebp
        mov     ebp,ecx
LPW_move0l:
        repne   movsd
        mov     ecx,ebp
        add     esi,ebx
        add     edi,edx
        dec     eax
        jne     LPW_move0l
        jmp     LPW_end

LPW_move1:
        or      eax,srcSizeY
        je      LPW_ret
        push    ebp
        mov     ebp,ecx
LPW_move1l:
        repne   movsd
        mov     ecx,ebp
        movsb
        add     edi,edx
        add     esi,ebx
        dec     eax
        jne     LPW_move1l
        jmp     LPW_end

LPW_move2:
        or      eax,srcSizeY
        je      LPW_ret
        push    ebp
        mov     ebp,ecx
LPW_move2l:
        repne   movsd
        mov     ecx,ebp
        movsw
        add     edi,edx
        add     esi,ebx
        dec     eax
        jne     LPW_move2l
        jmp     LPW_end

LPW_move3:
        or      eax,srcSizeY
        je      LPW_ret
        push    ebp
        mov     ebp,ecx
LPW_move3l:
        repne   movsd
        mov     ecx,ebp
        movsw
        movsb
        add     edi,edx
        add     esi,ebx
        dec     eax
        jne     LPW_move3l
        jmp     LPW_end

LPW_move4:
        mov     ecx,eax
        add     edx,4
        add     ebx,4
LPW_move4l:
        mov     eax,[esi]
        mov     es:[edi],eax
        add     edi,edx
        add     esi,ebx
        dec     ecx
        jne     LPW_move4l
        jmp     LPW_ret

LPW_rest:
        and     eax,3
        je      LPW_ret
        dec     eax
        je      LPW_rest1
        dec     eax
        je      LPW_rest2
        dec     eax
        jmp     LPW_rest3

LPW_rest1:
        or      eax,srcSizeY
        je      LPW_ret
LPW_rest1l:
        movsb
        add     edi,edx
        add     esi,ebx
        dec     eax
        jne     LPW_rest1l
        jmp     LPW_ret

LPW_rest2:
        or      eax,srcSizeY
        je      LPW_ret
LPW_rest2l:
        movsw
        add     edi,edx
        add     esi,ebx
        dec     eax
        jne     LPW_rest2l
        jmp     LPW_ret

LPW_rest3:
        or      eax,srcSizeY
        je      LPW_ret
LPW_rest3l:
        movsw
        movsb
        add     edi,edx
        add     esi,ebx
        dec     eax
        jne     LPW_rest3l
        jmp     LPW_ret
LPW_end:
        pop     ebp
LPW_ret:
        ret


_LIN_movWin_    ENDP

_L256_memset    PROC USES edi esi eax ebx ecx edx,
        buf :   dword, value : dword, count : dword

        mov     edi,buf
        mov     eax,value
        mov     ecx,count
        mov     ah,al
        mov     edx,eax
        shl     edx,16
        or      eax,edx
        mov     edx,ecx
        shr     ecx,2
        repne   stosd
        mov     ecx,edx
        and     ecx,3
        repne   stosb
        ret
_L256_memset    ENDP

_L256_movSpr2_  PROC USES esi edi eax ebx ecx edx,
        offset1    : dword, offset2    : dword,
        src        : dword, srcFormatX : dword,
        srcSizeX   : dword, srcSizeY   : dword

        LOCAL restX      : dword
        LOCAL dstFormatX : dword

        cmp     srcSizeY,0
        je      LPS_end

        mov     eax,srcSizeX
        mov     edx,eax
        and     eax,3
        mov     restX,eax

        mov     ecx,srcFormatX
        sub     ecx,edx
        add     ecx,eax
        mov     srcFormatX,ecx

        mov     ecx,_SVGA_virtualX
        sub     ecx,edx
        mov     dstFormatX,ecx

        shr     edx,2
        mov     srcSizeX,edx

        mov     esi,src
        mov     edi,offset1
        mov     ebx,offset2

LPS2_loopY:
        mov     ecx,srcSizeX
        or      ecx,ecx
        je      LPS2_rest

LPS2_load:
        lodsd
        or      eax,eax
        je      LPS2_skip4
        mov     edx,eax
        shr     edx,16
        or      al,al
        je      LPS2_d1
        or      ah,ah
        je      LPS2_d2
        or      dl,dl
        je      LPS2_d3
        or      dh,dh
        je      LPS2_d4
        mov     es:[edi],eax
        mov     es:[ebx],eax
LPS2_skip4:
        add     edi,4
        add     ebx,4
        jmp     LPS2_next
LPS2_d1:
        inc     edi
        inc     ebx
        jmp     LPS2_n1
LPS2_d2:
        stosb
        mov     es:[ebx],al
        inc     ebx
        jmp     LPS2_n2
LPS2_d3:
        stosw
        mov     es:[ebx],ax
        add     ebx,2
        jmp     LPS2_n3
LPS2_d4:
        stosw
        mov     es:[ebx],ax
        add     ebx,2
        mov     es:[ebx],dl
        inc     ebx
        mov     es:[edi],dl
        inc     edi
        jmp     LPS2_n4
LPS2_n1:
        or      ah,ah
        je      LPS2_n2
        mov     es:[edi],ah
        mov     es:[ebx],ah
LPS2_n2:
        inc     edi
        inc     ebx
        or      dl,dl
        je      LPS2_n3
        mov     es:[edi],dl
        mov     es:[ebx],dl
LPS2_n3:
        inc     edi
        inc     ebx
        or      dh,dh
        je      LPS2_n4
        mov     es:[edi],dh
        mov     es:[ebx],dh
LPS2_n4:
        inc     edi
        inc     ebx
LPS2_next:
        dec     ecx
        jne     LPS2_load

LPS2_rest:
        or      ecx,restX
        je      LPS2_nextLine

        mov     eax,[esi]
LPS2_rest1:
        or      al,al
        je      LPS2_rest2
        mov     es:[edi],al
        mov     es:[ebx],al
LPS2_rest2:
        shr     eax,8
        je      LPS2_rest3
        inc     edi
        inc     ebx
        dec     ecx
        jne     LPS2_rest1
        jmp     LPS2_nextLine
LPS2_rest3:
        add     edi,ecx
        add     ebx,ecx
LPS2_nextLine:
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        add     esi,srcFormatX
        dec     srcSizeY
        jne     LPS2_loopY
LPS2_end:
        ret
_L256_movSpr2_  ENDP



_L256_movWin2_   PROC USES esi edi eax ebx ecx edx,
        offset1    : dword, offset2    : dword,
        src        : dword, srcFormatX : dword,
        srcSizeX   : dword, srcSizeY   : dword

        LOCAL   sizeX : dword, dstFormatX : dword

        mov     ecx,srcSizeX
        mov     edx,_SVGA_virtualX
        mov     eax,ecx
        and     ecx,0ffffffffh-3
        sub     edx,ecx
        sub     srcFormatX,ecx
        shr     ecx,2
        mov     sizeX,ecx
        mov     edi,offset1
        mov     ebx,offset2
        mov     esi,src
        je      LPW2_rest

LPW2_move:
        and     eax,3
        je      LPW2_move0
        dec     eax
        je      LPW2_move1
        dec     eax
        je      LPW2_move2
        dec     eax
        jmp     LPW2_move3

LPW2_move0:
        or      eax,srcSizeY
        je      LPW2_ret
        cmp     ecx,1
        je      LPW2_move4
        mov     dstFormatX,edx
        mov     edx,eax
LPW2_move0l:
        lodsd
        mov     es:[ebx],eax
        stosd
        add     ebx,4
        loop    LPW2_move0l
        mov     ecx,sizeX
        add     esi,srcFormatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     edx
        jne     LPW2_move0l
        jmp     LPW2_ret

LPW2_move1:
        or      eax,srcSizeY
        je      LPW2_ret
        mov     dstFormatX,edx
        mov     edx,eax
LPW2_move1l:
        lodsd
        mov     es:[ebx],eax
        stosd
        add     ebx,4
        loop    LPW2_move1l
        mov     eax,[esi]
        mov     ecx,sizeX
        mov     es:[edi],al
        add     esi,srcFormatX
        mov     es:[ebx],al
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     edx
        jne     LPW2_move1l
        jmp     LPW2_ret

LPW2_move2:
        mov     dstFormatX,edx
        or      eax,srcSizeY
        je      LPW2_ret
        mov     edx,eax
LPW2_move2l:
        lodsd
        mov     es:[ebx],eax
        stosd
        add     ebx,4
        loop    LPW2_move2l
        mov     eax,[esi]
        mov     ecx,sizeX
        mov     es:[edi],ax
        add     esi,srcFormatX
        mov     es:[ebx],ax
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     edx
        jne     LPW2_move2l
        jmp     LPW2_ret

LPW2_move3:
        mov     dstFormatX,edx
        or      eax,srcSizeY
        je      LPW2_ret
        mov     edx,eax
LPW2_move3l:
        lodsd
        mov     es:[ebx],eax
        stosd
        add     ebx,4
        loop    LPW2_move3l
        mov     eax,[esi]
        mov     ecx,sizeX
        mov     es:[edi],ax
        add     esi,srcFormatX
        mov     es:[ebx],ax
        shr     eax,8
        mov     es:[ebx+2],ah
        mov     es:[edi+2],ah
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     edx
        jne     LPW2_move3l
        jmp     LPW2_ret

LPW2_move4:
        mov     ecx,eax
        push    ebp
        mov     ebp,srcFormatX
        add     ebp,4
        add     edx,4
LPW2_move4l:
        mov     eax,[esi]
        add     esi,ebp
        mov     es:[edi],eax
        add     edi,edx
        mov     es:[ebx],eax
        add     ebx,edx
        dec     ecx
        jne     LPW2_move4l
        jmp     LPW2_end

LPW2_rest:
        and     eax,3
        je      LPW2_ret
        dec     eax
        je      LPW2_rest1
        dec     eax
        je      LPW2_rest2
        dec     eax
        jmp     LPW2_rest3

LPW2_rest1:
        or      eax,srcSizeY
        je      LPW2_ret
        push    ebp
        mov     ecx,eax
        mov     ebp,srcFormatX
LPW2_rest1l:
        mov     eax,[esi]
        add     esi,ebp
        mov     es:[edi],al
        add     edi,edx
        mov     es:[ebx],al
        add     ebx,edx
        dec     ecx
        jne     LPW2_rest1l
        jmp     LPW2_end

LPW2_rest2:
        or      eax,srcSizeY
        je      LPW2_ret
        push    ebp
        mov     ecx,eax
        mov     ebp,srcFormatX
LPW2_rest2l:
        mov     eax,[esi]
        add     esi,ebp
        mov     es:[edi],ax
        add     edi,edx
        mov     es:[ebx],ax
        add     ebx,edx
        dec     ecx
        jne     LPW2_rest2l
        jmp     LPW2_end

LPW2_rest3:
        or      eax,srcSizeY
        je      LPW2_ret
        push    ebp
        mov     ecx,eax
        mov     ebp,srcFormatX
LPW2_rest3l:
        mov     eax,[esi]
        mov     es:[edi],ax
        add     esi,ebp
        mov     es:[ebx],ax
        shr     eax,8
        mov     es:[edi+1],al
        add     edi,edx
        mov     es:[ebx+1],al
        add     ebx,edx
        dec     ecx
        jne     LPW2_rest3l
        jmp     LPW2_end
LPW2_end:
        pop     ebp
LPW2_ret:
        ret


_L256_movWin2_  ENDP


_TEXT   ENDS

                END
